From b7ba747b5cd147a5ef6cd02eb59877b4352fbd3a Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Sep 02 2020 04:24:39 +0000
Subject: [PATCH 810/2232] Only assume target dir if parent contains Cargo.toml


---

diff --git a/gen/build/src/paths.rs b/gen/build/src/paths.rs
index e49dddb..f05a927 100644
--- a/gen/build/src/paths.rs
+++ b/gen/build/src/paths.rs
@@ -87,7 +87,9 @@ pub(crate) fn search_parents_for_target_dir(out_dir: &Path) -> TargetDir {
         Err(_) => return TargetDir::Unknown,
     };
     loop {
-        if dir.ends_with("target") {
+        let is_target = dir.ends_with("target");
+        let parent_contains_cargo_toml = dir.with_file_name("Cargo.toml").exists();
+        if is_target && parent_contains_cargo_toml {
             return TargetDir::Path(dir);
         }
         if !dir.pop() {

